/*
Viral Loops v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package vloopapi

import (
	"encoding/json"
	"time"
)

// checks if the Reward type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Reward{}

// Reward Coupon created based on RewardConfig and Milestone
type Reward struct {
	Code string `json:"code"`
	ProjectId string `json:"project_id"`
	CampaignId string `json:"campaign_id"`
	AssignedAt time.Time `json:"assigned_at"`
}

// NewReward instantiates a new Reward object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReward(code string, projectId string, campaignId string, assignedAt time.Time) *Reward {
	this := Reward{}
	this.Code = code
	this.ProjectId = projectId
	this.CampaignId = campaignId
	this.AssignedAt = assignedAt
	return &this
}

// NewRewardWithDefaults instantiates a new Reward object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRewardWithDefaults() *Reward {
	this := Reward{}
	return &this
}

// GetCode returns the Code field value
func (o *Reward) GetCode() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Code
}

// GetCodeOk returns a tuple with the Code field value
// and a boolean to check if the value has been set.
func (o *Reward) GetCodeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Code, true
}

// SetCode sets field value
func (o *Reward) SetCode(v string) {
	o.Code = v
}

// GetProjectId returns the ProjectId field value
func (o *Reward) GetProjectId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ProjectId
}

// GetProjectIdOk returns a tuple with the ProjectId field value
// and a boolean to check if the value has been set.
func (o *Reward) GetProjectIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ProjectId, true
}

// SetProjectId sets field value
func (o *Reward) SetProjectId(v string) {
	o.ProjectId = v
}

// GetCampaignId returns the CampaignId field value
func (o *Reward) GetCampaignId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CampaignId
}

// GetCampaignIdOk returns a tuple with the CampaignId field value
// and a boolean to check if the value has been set.
func (o *Reward) GetCampaignIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CampaignId, true
}

// SetCampaignId sets field value
func (o *Reward) SetCampaignId(v string) {
	o.CampaignId = v
}

// GetAssignedAt returns the AssignedAt field value
func (o *Reward) GetAssignedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.AssignedAt
}

// GetAssignedAtOk returns a tuple with the AssignedAt field value
// and a boolean to check if the value has been set.
func (o *Reward) GetAssignedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AssignedAt, true
}

// SetAssignedAt sets field value
func (o *Reward) SetAssignedAt(v time.Time) {
	o.AssignedAt = v
}

func (o Reward) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Reward) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["code"] = o.Code
	toSerialize["project_id"] = o.ProjectId
	toSerialize["campaign_id"] = o.CampaignId
	toSerialize["assigned_at"] = o.AssignedAt
	return toSerialize, nil
}

type NullableReward struct {
	value *Reward
	isSet bool
}

func (v NullableReward) Get() *Reward {
	return v.value
}

func (v *NullableReward) Set(val *Reward) {
	v.value = val
	v.isSet = true
}

func (v NullableReward) IsSet() bool {
	return v.isSet
}

func (v *NullableReward) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReward(val *Reward) *NullableReward {
	return &NullableReward{value: val, isSet: true}
}

func (v NullableReward) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReward) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


